<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="代理名称" prop="frpcName">
        <el-input v-model="formData.frpcName" placeholder="请输入代理名称" />
      </el-form-item>
      <el-form-item label="内网IP" prop="localIp">
        <el-input v-model="formData.localIp" placeholder="请输入内网IP" />
      </el-form-item>
      <el-form-item label="内网端口" prop="localPort">
        <el-input v-model="formData.localPort" placeholder="请输入内网端口" />
      </el-form-item>
      <el-form-item label="访问后缀" prop="suffixPath">
        <el-input v-model="formData.suffixPath" placeholder="请输入访问后缀" />
      </el-form-item>

      <el-form-item label="代理服务器" prop="frpsId">
        <el-input v-model="formData.frpsId" placeholder="请输入代理服务器" />
      </el-form-item>
      <el-form-item label="代理端口" prop="proxyPort">
        <el-input v-model="formData.proxyPort" placeholder="请输入代理端口" />
      </el-form-item>
      <el-form-item label="代理地址" prop="proxyAddress">
        <el-input v-model="formData.proxyAddress" placeholder="请输入代理地址" />
      </el-form-item>

      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="是否启用" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { FrpcProxyServerApi, FrpcProxyServerVO } from '@/api/iot/frpc'

/** 代理服务 表单 */
defineOptions({ name: 'FrpcProxyServerForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  frpcName: undefined,
  localIp: undefined,
  localPort: undefined,
  suffixPath: undefined,
  localStatus: undefined,
  frpsId: undefined,
  proxyPort: undefined,
  proxyAddress: undefined,
  proxyStatus: undefined,
  remark: undefined,
  isEnable: undefined,
})
const formRules = reactive({
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FrpcProxyServerApi.getFrpcProxyServer(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as FrpcProxyServerVO
    if (formType.value === 'create') {
      await FrpcProxyServerApi.createFrpcProxyServer(data)
      message.success(t('common.createSuccess'))
    } else {
      await FrpcProxyServerApi.updateFrpcProxyServer(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    frpcName: undefined,
    localIp: undefined,
    localPort: undefined,
    suffixPath: undefined,
    localStatus: undefined,
    frpsId: undefined,
    proxyPort: undefined,
    proxyAddress: undefined,
    proxyStatus: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
